Subject: Re: bug#50143: 28.0.50; Various issues with `tamil-itrans' input method

From: Eli Zaretskii <[email-masked]>
Date: Sun, 22 Aug 2021 10:28:06 +0300

> From: Ramesh Nedunchezian <[email-masked]>
> Date: Sat, 21 Aug 2021 14:55:23 +0530
> 
> I am working on `tamil-phonetic.el`, a "Tamil Phonetic Input for
> Emacs".  See https://github.com/rnchzn/tamil-phonetic and
> https://raw.githubusercontent.com/rnchzn/tamil-phonetic/main/tamil-phonetic.el.
> I will be submitting this library for inclusion in NON GNU ELPA.

Thanks in advance.  is there any reason why you couldn't submit this
to GNU ELPA or even to Emacs itself?  Input methods are generally
considered to be the stuff for Emacs core, not for third-party
packages.

> In preparation for that step, I desire fixes for three issues listed
> below.  Of these first two are bugs, and the last is an API
> enhancement request.
> 
> 1. The `indian-tml-base-table' has no entries for letters ௐ and ஶ.
>    The fix for this would be to do this:
> 
>         (setcar (nthcdr (seq-position (nth 2 indian-itrans-v5-table-for-tamil) '("AUM" "OM")
>                                       (lambda (s1 s2)
>                                         (when (and (consp s1) (consp s2))
>                                           (string= (car s1) (car s2)))))
>                         (nth 2 indian-tml-base-table))
>                 ?ௐ)
> 
>         (setcar (nthcdr (seq-position (nth 1 indian-itrans-v5-table-for-tamil) "sh"
>                                       (lambda (s1 s2)
>                                         (when (and (stringp s1) (stringp s2))
>                                           (string= s1 s2))))
>                         (nth 1 indian-tml-base-table))
>                 ?ஶ)
> 
>    I have chosen entry for "sh" above because of the recommendations
>    in the following link https://github.com/avinash311/itrans and 
>    https://docs.google.com/spreadsheets/d/14wZl8zCa4khZV3El2VGoqurKBLGx21mbS-yORi4w7Qo/edit#gid=0

I'm not sure I understand how changes to
indian-itrans-v5-table-for-tamil could affect indian-tml-base-table.
Could you explain what I missed?

In any case, please propose the changes to do the above in the form of
a patch for lisp/language/ind-util.el.

> 2. M-x describe-input-method RET tamil-itrans RET doesn't show the
>    help table. i.e., instead of saying
> 
>    > Uses keymap ‘quail-tamil-itrans-syllable-table’, which is not currently defined.
> 
>    it should display the value of `quail-tamil-itrans-syllable-table'
>    inline.
> 
>    The problem is the docstring uses "keymap" syntax, when in actual
>    fact, that variable in NOT a keymap but a text with some display
>    properties.
> 
>    There are two more such variables that have the same issues as
>    above variable.
>    
>    See the attached screenshot.

Again, could you please propose a patch to do this?

> 3. `indian-make-hash` ALWAYS installs translation for decimal digits
>    0-9.  Tamil decimal digits are NOT used at all i.e., it is not even
>    taught in Schools in the state of TamilNadu, India.  So, I wanted a
>    way NOT to insall the translation for digits.  I suggest one of the
>    following:
> 
>    - Change signature of `(indian-make-hash TABLE TRANS-TABLE)' to
>      `(indian-make-hash TABLE TRANS-TABLE &optional
>      DONT-INSTALL-NATIVE-DIGITS)' or some such thing.

This change of the API is acceptable, so please propose a patch along
these lines.

>      `indian-make-hash' is used by many indic scripts, so I am not
>      sure if other indian language users would have a need for
>      inputting native decimal digits.  I--as a representative of Tamil
>      speakers--can say that we don't need that ON by default.

We can use this for Tamil only for now, and wait for users of other
languages to chime in.

Thanks.